﻿(function () {

    "use strict";

    angular.module("enrDetailsPaneModule")
           .factory("detailsData", ["$rootScope", function ($rootScope) {

               var dataChangedEventName = "detailsDataChanged";
               var curJson;

            var setData = function(json) {
                curJson = json;

                $rootScope.$broadcast(dataChangedEventName, curJson);

                // (Potentially) costly syncronous logic complete. Can safely remove busy working dialog.
                $rootScope.$broadcast("POP_BUSY_WORKING", curJson);
            };

               return {
                   dataChangedEventName: dataChangedEventName,

                   isDataPresent: function () { return curJson !== undefined && curJson !== null; },

                   getData: function () { return curJson; },
                   setData: function (json) { setData(json) },

                   clearData: function () { setData(undefined); }
               };
           }]);

}());